//+------------------------------------------------------------------+
//|                                                BS_Stochastic.mq4 |
//|                                        Copyright  2008, masemus |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//mod2008fxtsd ki
#property copyright "Copyright  2008, masemus"
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -1.2
#property indicator_maximum 1.7
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 Green

/*
Price Options
PRICE_CLOSE = 0 Close price. 
PRICE_OPEN = 1 Open price. 
PRICE_HIGH = 2 High price. 
PRICE_LOW = 3 Low price. 
PRICE_MEDIAN = 4 Median price, (high+low)/2. 
PRICE_TYPICAL = 5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED = 6 Weighted close price, (high+low+close+close)/4. 

Ma Options
MODE_SMA = 0 Simple moving average, 
MODE_EMA = 1 Exponential moving average, 
MODE_SMMA = 2 Smoothed moving average, 
MODE_LWMA = 3 Linear weighted moving average. 
Stoch. PriceField: 0-L/H; 1-C/C 

note_TF = "60H1,240H4,1440D1,10080W1,43200MN1";
*/

extern int TimeFrame = 0;
extern int K_period = 5;
extern int D_period = 3;
extern int S_period = 3;
extern int PriceField = 0;
extern int MA_Method = 0;

extern int PeriodRSI=5;

extern int SMA_Fast = 1;
extern int SMA_Slow = 4;

double MainBuffer1[];
double MainBuffer2[];
double ExtMapBuffer1[];
string TimeFrameStr;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   //---- indicator line
   SetIndexBuffer(0,MainBuffer1);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(1,MainBuffer2);
   SetIndexStyle(1,DRAW_SECTION);
    SetIndexBuffer(2,ExtMapBuffer1);
    SetIndexStyle(2,DRAW_SECTION);
    
    SetIndexLabel(0,"SB_Sto");
    SetIndexLabel(1,"SB_RSI");
    SetIndexLabel(2,"SB_MAs");

    
switch(TimeFrame)
   {
      case 1 : TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      default : TimeFrameStr="TF0"; TimeFrame=0;
   }
  IndicatorShortName("SB Sto ("+K_period+","+D_period+","+S_period+
  ")  RSI "+PeriodRSI+"; MAs ("+SMA_Fast+","+SMA_Slow+") ["+TimeFrameStr+"]");  

 
//----
   return(0);
  }
   
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//  ObjectsDeleteAll(0,OBJ_LABEL);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| MTF Stochastic                                                   |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,shift,limit,y=0,counted_bars=IndicatorCounted();
    
// Plot defined timeframe on to current timeframe   
   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
  
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
  if (Time[i]<TimeArray[y]) y++; 

  MainBuffer1[i]=0;
  MainBuffer2[i]=0;
   
  double BS_Stochastic;
     
  BS_Stochastic=iStochastic(NULL,TimeFrame,K_period,D_period,S_period,MA_Method,PriceField,MODE_MAIN,y);

  if (BS_Stochastic>50)MainBuffer1[i]=1.1;
  if (BS_Stochastic<50)MainBuffer1[i]=-1.1;
   
  
     double BS_RSI;
   
   BS_RSI=iRSI(NULL,TimeFrame,PeriodRSI,PRICE_CLOSE,y);
   	
	  if (BS_RSI>50)MainBuffer2[i]=0.7;
	  if (BS_RSI<50)MainBuffer2[i]=-0.7;
	  
	  
	  
	    
    ExtMapBuffer1[i]=0;

   double BS_Signal=iMA(NULL,TimeFrame,SMA_Fast,PRICE_CLOSE,MODE_SMA,0,y);
   double BS_Trend=iMA(NULL,TimeFrame,SMA_Slow,PRICE_CLOSE,MODE_SMA,0,y);
   
   if(BS_Signal > BS_Trend)ExtMapBuffer1[i] = 0.3;
   if(BS_Signal < BS_Trend)ExtMapBuffer1[i] = - 0.3;

}
   return(0);
  }
//+------------------------------------------------------------------+